/**
 * Marks that `thing` is exported from the `grafast` module as
 * `exportName` so that `graphile-export` can convert references to `thing`
 * into an `import` statement.
 *
 * @internal
 */
export declare function exportAs<T extends object>(moduleName: string, thing: T, exportName: string | string[]): T;
/**
 * Marks that each value in `all` is exported from the `grafast`
 * module as the key in the `all` object so that `graphile-export` can
 * convert references to these values into `import` statements.
 *
 * @internal
 */
export declare function exportAsMany(moduleName: string, all: {
    [key: string]: any;
}): void;
//# sourceMappingURL=exportAs.d.ts.map