import type { GrafastPlanJSON } from "./interfaces";
/**
 * An array of hex colour codes that we use for colouring the buckets/steps in
 * the mermaid-js plan diagram.
 *
 * Generated by mokole.com/palette.html; re-ordered by Jem
 */
export declare const COLORS: string[];
/**
 * Given a string, escapes the string so that it can be embedded as the description of a node in a mermaid chart.
 *
 * 1. If it's already safe, returns it verbatim
 * 2. If it contains disallowed characters, escape them by replacing them with similar-looking characters,
 * 3. Wrap the string in quote marks.
 *
 * @remarks
 *
 * NOTE: rather than doing literal escapes, we replace with lookalike characters because:
 *
 * 1. Mermaid has a bug when calculating the width of the node that doesn't respect escapes,
 * 2. It's easier to read the raw mermaid markup with substitutes rather than messy escapes.
 *
 * @internal
 */
export declare const mermaidEscape: (str: string) => string;
export interface PrintPlanGraphOptions {
    printPathRelations?: boolean;
    includePaths?: boolean;
    concise?: boolean;
    skipBuckets?: boolean;
}
export declare function planToMermaid(planJSON: GrafastPlanJSON, { concise, skipBuckets, }?: PrintPlanGraphOptions): string;
export * from "./planJSONInterfaces.js";
//# sourceMappingURL=mermaid.d.ts.map