import type { LayerPlanReasonSubroutine } from "../engine/LayerPlan.js";
import { LayerPlan } from "../engine/LayerPlan.js";
import type { GrafastError } from "../error.js";
import type { ExecutionExtra, GrafastResultsList, GrafastValuesList } from "../interfaces.js";
import type { ListCapableStep } from "../step.js";
import { ExecutableStep } from "../step.js";
/**
 * @internal
 */
export declare class ApplyTransformsStep extends ExecutableStep {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    /** Set during query planning.  */
    itemStepId: number;
    /**
     * @internal
     */
    subroutineLayer: LayerPlan<LayerPlanReasonSubroutine>;
    constructor(listPlan: ListCapableStep<any, any>);
    execute(_count: number, values: [GrafastValuesList<any[] | null | undefined | GrafastError>], extra: ExecutionExtra): Promise<GrafastResultsList<any[]>>;
}
/**
 * If you want to use a step that might represent a list and you need all of
 * the `listItem` transforms to have already taken place (e.g. you're going to
 * send the result to an external service) rather than processing them through
 * the GraphQL response, then you may need to call `applyTransforms` on it.
 */
export declare function applyTransforms($step: ExecutableStep): ExecutableStep<any>;
//# sourceMappingURL=applyTransforms.d.ts.map